(require (file "../spur.scm"))

;;;  This is a test file that repeatedly plays individual notes at 200 bpm
;;;  Every 8th note is a C that is emphasized in velocity.

(define met (make-metro 200))      ; tempo is 200 bpm
(define major '(2 4 5 7 9 11 12))  ; full major scale

(define (velo beat) 
  (+ 50 (* 20 (cos (* beat (/ pi 4))))))
(define (pitch beat) 
  (+ 48 (if (= (remainder beat 8) 0) 0 (rand '(4 5)))))

(define (pulse beat)
  (schedule-note (met beat) 1 (pitch beat) (velo beat) (met 'dur .8))
  (schedule (met (+ beat .9)) pulse (+ beat 1)))

(define (main) (with-midi-schedule (pulse (met 'get-beat 8))))
