#lang racket

;; load the functions midi-open, midi-close, and message
(require "evhan-coremidi.scm")
; (require "portmidi-output.scm")   ; this is an alternate way to go

(define device-number 0)          ; the number of the MIDI out device 
(define midi-device #f)           ; the MIDI device as a global variable

(define (open-midi-device) (set! midi-device (midi-open device-number)))
(define (close-midi-device) (midi-close midi-device) (set! midi-device #f))

(define ON #x90)  ; note on
(define (note-on channel note (velocity 64))
  (message midi-device (bitwise-ior ON (- channel 1)) note velocity))

(define OFF #x80) ; note off
(define (note-off channel note (velocity 64))
  (message midi-device (bitwise-ior OFF (- channel 1)) note velocity))

(define AT #xA0)  ; aftertouch
(define (aftertouch channel note touch)
  (message midi-device (bitwise-ior AT (- channel 1)) note touch))

(define PC #xC0)  ; program change 
(define (program-change channel preset)
  (message midi-device (bitwise-ior PC (- channel 1)) preset 0))

(define CC #xB0)  ; control change
(define (control-change channel controlnum value)
  (message midi-device  (bitwise-ior CC (- channel 1)) controlnum value))

(define PB #xE0)  ; pitch bend
(define (pitch-bend channel value)
  (message midi-device (bitwise-ior PB (- channel 1))
           (remainder value 128) (quotient value 128)))

(provide open-midi-device close-midi-device 
     note-off note-on aftertouch control-change pitch-bend program-change)
