;;; This uses the Emacs cmuscheme library to run Racket
;;; Put (autoload 'run-spur "/path/to/this/file.el" "" t) in .emacs

(require 'cmuscheme)

;; This should be set to the path for the Racket binary.  Watch for spaces!
(setq scheme-program-name "/Applications/Racket\\ v5.2/bin/racket")

(defun run-spur ()
  "Start Racket in an inferior scheme process, running (main) as a thread"
  (interactive)
  (set-buffer 
   (make-comint "scheme" "/bin/sh" nil "-c" 
      (concat scheme-program-name 
         " -iqf " (buffer-file-name)
         " -e '(define main-thread (thread main))'")))
  (inferior-scheme-mode)
  (set-process-query-on-exit-flag (get-buffer-process "*scheme*") nil)
  (setq scheme-buffer "*scheme*"))

(defun kill-spur ()
  "Stop Racket in an inferior scheme process"
  (interactive)
  (process-send-string (get-buffer-process "*scheme*") 
     "(kill-thread main-thread)\n
      (for ([i 16]) (control-change (+ i 1) 123 0))\n")
  (sleep-for .5)
  (kill-buffer scheme-buffer))
